/* -------------------------------------------------------------------------- */
/* -                 Astronomical CCD Camera Control                        - */
/* -               Apogee Camera Protocol Header File                       - */
/* -------------------------------------------------------------------------- */
/*                                                                            */
/* Copyright 2009-2012 John Kielkopf                                          */
/* kielkopf@louisville.edu                                                    */
/*                                                                            */
/* This file is part of XmCCD.                                                */
/*                                                                            */
/* XmCCD is free software: you can redistribute it and/or modify              */
/* it under the terms of the GNU General Public License as published by       */
/* the Free Software Foundation, either version 3 of the License, or          */
/* (at your option) any later version.                                        */
/*                                                                            */
/* XmCCD is distributed in the hope that it will be useful,                   */
/* but WITHOUT ANY WARRANTY; without even the implied warranty of             */
/* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the              */
/* GNU General Public License for more details.                               */   
/*                                                                            */
/* Date: March 28, 2012                                                       */
/* Version 4.0                                                                */

#include <libapogeedrv.h>

/* Supported interfaces */

#define USB              0
#define ETH              1
#define PIO              2

/* Default hex ip address 192.168.0.1 */

#define CCD_ETH  0xc0a80001 


/* Device status flags */

#define IDLE 0
#define INTEGRATING 1
#define COMPLETE 2

/* Shutter flag */

#define LEAVE    0
#define OPEN     1
#define CLOSED   2

/* Frame type */

#define DARK     0     
#define LIGHT    1
#define BIAS     2  
#define FLAT     3  

